#!/bin/sh

. "$LIXROOT/lib/versionformat.sh"

guessver() {
    pkg="$1"
    tgt="${2:-$pkg}"

    if [ -f "$LIXROOT/build-conf/$pkg" ]; then 
        awk '$1 == "'$tgt'" { print $2 }' "$LIXROOT/build-conf/$tgt"
        return 0
    fi

    printf '%s\n%s\n%s' \
        "$(version=''; eval "$(src -d $tgt 2> /dev/null)"; echo "$version")" \
        "$(ls "$HOWROOT/pkg/$tgt" 2>/dev/null)" \
        "$(built "$tgt" 2> /dev/null)" \
    | grep -vE '^default$|^$' \
    | shsort -r "vercmp -f $(versionformat "$tgt")" 2> /dev/null \
    | tail -n1
}
